// 05_1.c - s񎮂̃vO (LU - Doolittle@)

#include <stdio.h>
#include <math.h>

#define	N	3		// s̎
#define TOL	1.0e-6	// 0l

void PrintMatrixD(double M[N][N]);
void PrintLUMatrixPD(double M[N][N]);
int PivotRow(double M[N][N], int diag, int *pid);

int main()
{
	int i, j, k;
	int tmp, ret;
	int pivot[N];	// s{bgIL^
	int pid;		// s{bgIsID
	double A[N][N] = {
		{ 2, 3, 5 }, 
		{ 3, 1, 4 }, 
		{ -1, 2, 3 }
	};
	double detA = 1.0;	// s|A|
	double m = 0;
	double dtmp;

	printf("-----s (LU)-----\n");
	printf("A = LU =\n");
	PrintMatrixD(A);

	for (i = 0; i < N; i++) pivot[i] = i;

	// sւ
	ret = PivotRow(A, 0, &pid);
	if (ret > 0)
	{
		// s{bgIL^
		tmp = pivot[0];
		pivot[0] = pid;
		pivot[pid] = tmp;
		m++;
	}
	else if (ret < 0)
	{
		printf(">> |os\\n");
		return 1;
	}

	// Ls̑1vZ
	for (i = 1; i < N; i++) A[i][0] /= A[0][0];

	for (i = 1; i < N; i++)
	{
		// Us̍svZ
		for (j = i; j < N; j++)
		{
			for (k = i; k < N; k++) A[j][k] -= A[j][i - 1] * A[i - 1][k];
		}
		
		if (i < (N - 1))
		{
			// sւ
			ret = PivotRow(A, i, &pid);
			if (ret > 0)
			{
				// s{bgIL^
				tmp = pivot[i];
				pivot[i] = pid;
				pivot[pid] = i;
				m++;

				// Lsւ
				for (j = 0; j < i; j++)
				{
					dtmp = A[i][j];
					A[i][j] = A[pid][j];
					A[pid][j] = dtmp;
				}
			}
			else if (ret < 0)
			{
				printf(">> |os\\n");
				return 1;
			}
		}

		// Ls̗vZ
		for (j = i + 1; j < N; j++) A[j][i] /= A[i][i];
	}

	PrintLUMatrixPD(A);

	// s񎮂߂
	for (i = 0; i < N; i++) detA *= A[i][i];
	for (i = 0; i < m; i++) detA *= -1.0;
	printf("\n| A | = %10.6lf\n", detA);

	return 0;
}


//--------------------------------------------------
//  y@\z N~Nsidouble^j\o͂
//  yz M: Ώۂ̍s
//  y߂lz 
//--------------------------------------------------
void PrintMatrixD(double M[N][N])
{
	int i;
	int j;

	for (i = 0; i < N; i++)
	{
		for (j = 0; j < N; j++)
		{
			printf("\t%lf", M[i][j]);
		}
		printf("\n");
	}
}


//------------------------------------------------------------
//  y@\z LUN~Nsidouble^j\o͂
//           (s{bgIL)
//  yz M: Ώۂ̍s
//  y߂lz 
//------------------------------------------------------------
void PrintLUMatrixPD(double M[N][N])
{
	int i;
	int j;

	// Ls\
	printf("L =\n");
	for (i = 0; i < N; i++)
	{
		for (j = 0; j < i; j++) printf("\t%lf", M[i][j]);
		printf("\t%lf", 1.0);
		for (j = i + 1; j < N; j++) printf("\t%lf", 0.0);
		printf("\n");
	}

	// Us\
	printf("\nU =\n");
	for (i = 0; i < N; i++)
	{
		for (j = 0; j < i; j++) printf("\t%lf", 0.0);
		for (j = i; j < N; j++) printf("\t%lf", M[i][j]);
		printf("\n");
	}
}


//----------------------------------------------------------------------------
//  y@\z ŝΊpɂāCŐΒlő̍sƓւ
//  yz M: Ώۂ̍s, diag: ΊpID, pid: ő̍sID̃|C^
//  y߂lz ւtO(-1: |os\, 0: ւ, 1: L)
//----------------------------------------------------------------------------
int PivotRow(double M[N][N], int diag, int *pid)
{
	int	i;
	double tmp;
	double pivot;	// s{bgl

	*pid = diag;

	// Βlő̍sT
	for (i = diag + 1; i < N; i++)
	{
		if (fabs(M[i][diag]) > fabs(M[*pid][diag])) *pid = i;
	}
	if (*pid == diag)
	{
		if (fabs(M[diag][diag]) < TOL) return -1;
		else return 0;
	}

	// sւ
	for (i = diag; i < N; i++)
	{
		tmp = M[diag][i];
		M[diag][i] = M[*pid][i];
		M[*pid][i] = tmp;
	}

	return 1;
}