// 05_2.c - ts̃vO (LU - Doolittle@)

#include <stdio.h>
#include <math.h>

#define	N	3		// s̎
#define TOL	1.0e-6	// 0l

int LUDecomp(double M[N][N], int pivot[N]);
void PrintMatrixD(double M[N][N]);
void PrintLUMatrixPD(double M[N][N]);
int PivotRow(double M[N][N], int diag, int *pid);

int main()
{
	int i, j, k;
	int pivot[N];			// s{bgIL^
	double A[N][N] = {
		{ 0, 1, 2 }, 
		{ -2, 3, 1 }, 
		{ 1, 0, 2 }
	};
	double Y[N][N] = {
		{ 0, 0, 0 }, 
		{ 0, 0, 0 }, 
		{ 0, 0, 0 }
	};						// UA^(-1)
	double I[N][N] = {
		{ 1, 0, 0 },
		{ 0, 1, 0 },
		{ 0, 0, 1 }
	};						// Pʍs(萔)
	double INV[N][N] = {
		{ 0, 0, 0 },
		{ 0, 0, 0 },
		{ 0, 0, 0 }
	};						// ts A^(-1)
	double dtmp;

	printf("-----ts (LU)-----\n");

	// LU
	if (LUDecomp(A, pivot) < 0) return 1;

	// Pʍs(萔)ւ
	for (i = 0; i < N; i++)
	{
		if (i < pivot[i])
		{
			for (j = 0; j < N; j++)
			{
				dtmp = I[i][j];
				I[i][j] = I[pivot[i]][j];
				I[pivot[i]][j] = dtmp;
			}
		}
	}
	printf("\nPI =\n");
	PrintMatrixD(I);

	// Oi
	for (j = 0; j < N; j++)
	{
		for (i = 0; i < N; i++)
		{
			Y[i][j] = I[i][j];
			for (k = 0; k < i; k++) Y[i][j] -= A[i][k] * Y[k][j];
		}
	}

	printf("\nY = UA^(-1) =\n");
	PrintMatrixD(Y);

	// ޑ
	for (j = 0; j < N; j++)
	{
		for (i = N-1 ; i >= 0; i--)
		{
			INV[i][j] = Y[i][j];
			for (k = i + 1; k < N; k++)
			{
				INV[i][j] -= A[i][k] * INV[k][j];
			}
			INV[i][j] /= A[i][i];
		}
	}

	printf("\nA^(-1) =\n");
	PrintMatrixD(INV);

	return 0;
}


//------------------------------------------------------
//  y@\z N~NsLU
//  yz M: Ώۂ̍s, pivot: s{bgIL^
//  y߂lz (-1: |os\, 0: )
//------------------------------------------------------
int LUDecomp(double M[N][N], int pivot[N])
{
	int i, j, k;
	int tmp, ret;
	int pid;		// s{bgIsID
	double dtmp;

	printf("A = LU =\n");
	PrintMatrixD(M);

	for (i = 0; i < N; i++) pivot[i] = i;

	// sւ
	ret = PivotRow(M, 0, &pid);
	if (ret > 0)
	{
		// s{bgIL^
		tmp = pivot[0];
		pivot[0] = pid;
		pivot[pid] = 0;
	}
	else if (ret < 0)
	{
		printf(">> |os\\n");
		return 1;
	}

	// Ls̑1vZ
	for (i = 1; i < N; i++) M[i][0] /= M[0][0];

	for (i = 1; i < N; i++)
	{
		// Us̍svZ
		for (j = i; j < N; j++)
		{
			for (k = i; k < N; k++) M[j][k] -= M[j][i - 1] * M[i - 1][k];
		}

		if (i < (N - 1))
		{
			// sւ
			ret = PivotRow(M, i, &pid);
			if (ret > 0)
			{
				// s{bgIL^
				tmp = pivot[i];
				pivot[i] = pid;
				pivot[pid] = i;

				// Lsւ
				for (j = 0; j < i; j++)
				{
					dtmp = M[i][j];
					M[i][j] = M[pid][j];
					M[pid][j] = dtmp;
				}
			}
			else if (ret < 0)
			{
				printf(">> |os\\n");
				return 1;
			}
		}

		// Ls̗vZ
		for (j = i + 1; j < N; j++) M[j][i] /= M[i][i];
	}

	PrintLUMatrixPD(M);

	return 0;
}


//--------------------------------------------------
//  y@\z N~Nsidouble^j\o͂
//  yz M: Ώۂ̍s
//  y߂lz 
//--------------------------------------------------
void PrintMatrixD(double M[N][N])
{
	int i;
	int j;

	for (i = 0; i < N; i++)
	{
		for (j = 0; j < N; j++)
		{
			printf("\t%lf", M[i][j]);
		}
		printf("\n");
	}
}


//------------------------------------------------------------
//  y@\z LUN~Nsidouble^j\o͂
//           (s{bgIL)
//  yz M: Ώۂ̍s
//  y߂lz 
//------------------------------------------------------------
void PrintLUMatrixPD(double M[N][N])
{
	int i;
	int j;

	// Ls\
	printf("L =\n");
	for (i = 0; i < N; i++)
	{
		for (j = 0; j < i; j++) printf("\t%lf", M[i][j]);
		printf("\t%lf", 1.0);
		for (j = i + 1; j < N; j++) printf("\t%lf", 0.0);
		printf("\n");
	}

	// Us\
	printf("\nU =\n");
	for (i = 0; i < N; i++)
	{
		for (j = 0; j < i; j++) printf("\t%lf", 0.0);
		for (j = i; j < N; j++) printf("\t%lf", M[i][j]);
		printf("\n");
	}
}


//----------------------------------------------------------------------------
//  y@\z ŝΊpɂāCŐΒlő̍sƓւ
//  yz M: Ώۂ̍s, diag: ΊpID, pid: ő̍sID̃|C^
//  y߂lz ւtO(-1: |os\, 0: ւ, 1: L)
//----------------------------------------------------------------------------
int PivotRow(double M[N][N], int diag, int *pid)
{
	int	i;
	double tmp;
	double pivot;	// s{bgl

	*pid = diag;

	// Βlő̍sT
	for (i = diag + 1; i < N; i++)
	{
		if (fabs(M[i][diag]) > fabs(M[*pid][diag])) *pid = i;
	}
	if (*pid == diag)
	{
		if (fabs(M[diag][diag]) < TOL) return -1;
		else return 0;
	}

	// sւ
	for (i = diag; i < N; i++)
	{
		tmp = M[diag][i];
		M[diag][i] = M[*pid][i];
		M[*pid][i] = tmp;
	}

	return 1;
}